﻿using System;
using System.Drawing;

namespace SQLSaturdayLibrary
{
    public static class ProductShapeBitmapCreator
    {
        public const float PenWidth = 2;
        public static byte[] CreateProductShape(int width, int height, string color)
        {
            Bitmap returnValue = new Bitmap(width, height, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
            using (Graphics worker = Graphics.FromImage(returnValue))
            {
                worker.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
                Pen imagePen = new Pen(Color.Black, PenWidth);
                Color colorFinal = Color.FromKnownColor((KnownColor)System.Enum.Parse(typeof(KnownColor), color));
                SolidBrush brush = new SolidBrush(colorFinal);
                worker.FillRectangle(brush, 0, 0, width, height);
                worker.DrawRectangle(imagePen, 0, 0, width, height);
            }
            byte[] data;
            using (System.IO.MemoryStream stream = new System.IO.MemoryStream())
            {
                returnValue.Save(stream, System.Drawing.Imaging.ImageFormat.Jpeg);
                data = stream.ToArray();
            }
            return data;
        }
    }
}
