﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Text.RegularExpressions;
using System.Collections;

public partial class UserDefinedFunctions
{
    [Microsoft.SqlServer.Server.SqlFunction]
    public static SqlDouble DifferenceInStrings(SqlString string1, SqlString string2)
    {
        return SQLSaturdayLibrary.LevenshteinDistance.EqualityPercent(string1.Value, string2.Value);
    }

    [Microsoft.SqlServer.Server.SqlFunction]
    [return: SqlFacet(MaxSize = -1)]
    public static SqlBinary GetProductShape(SqlInt32 width, SqlInt32 height, SqlString color)
    {
        return SQLSaturdayLibrary.ProductShapeBitmapCreator.CreateProductShape(width.Value, height.Value, color.Value);
    }

    [Microsoft.SqlServer.Server.SqlFunction]
    public static SqlMoney GetFinalPrice(SqlMoney basePrice)
    {
        return SQLSaturdayLibrary.Pricer.GetPrice(basePrice.Value);
    }

    [Microsoft.SqlServer.Server.SqlFunction]
    [return: SqlFacet(MaxSize = -1)]
    public static SqlBinary GetFileContent(SqlString fileName)
    {
        return System.IO.File.ReadAllBytes(fileName.Value);
    }

    [Microsoft.SqlServer.Server.SqlFunction]
    public static SqlBoolean IsEmailValid(SqlString email)
    {
        if (email.IsNull)
            return true;
        else
            return Regex.Match(email.Value, @"^[A-Za-z0-9._%-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,4}$").Success;
    }

    [SqlFunction(FillRowMethodName = "FillRow", TableDefinition = "value nvarchar(60)")]
    public static IEnumerable GetStringTable(SqlString str)
    {
        return str.Value.Split(',');
    }

    public static void FillRow(object row, out string oneString)
    {
        oneString = ((string)row).Trim();
    }


};

